-module(echo).
-export([listen/1,serve/1]).

-define(TCP_OPTIONS, [binary, {packet, 0}, {active, false}, {reuseaddr, true}]).

% listen(Port) starts the echo service on port Port
listen(Port) ->
    {ok, LSocket} = gen_tcp:listen(Port, ?TCP_OPTIONS),
    accept(LSocket).


% Wait for incoming connections and spawn a child whenever a request arrives
accept(LSocket) ->
    {ok, Socket} = gen_tcp:accept(LSocket),
    spawn(echo, serve, [Socket]),
    accept(LSocket).


% Echo back whatever data we receive on Socket.
serve(Socket) ->
    case gen_tcp:recv(Socket, 0) of
        {ok, Data} ->
            gen_tcp:send(Socket, Data),
	    gen_tcp:send(Socket, Data),
            serve(Socket);
	
        {error, closed} ->
            ok
    end.
