% try update with a single process
% start, change and recompile, print, switch, print

% try with two instances of the process running version 1, 2, and load a third


-module(hotSwap).
-export([start/0,loop/0,controller/0]).
-export([new/0,ver/1,upd/1,stop/1]).

% controller
controller() ->
    % Supervisor process: traps the exit signals
    process_flag(trap_exit, true),

    receive
	{new, Caller} ->
	    Pid = spawn_link(?MODULE, loop, []),
	    Caller!Pid,
	    ?MODULE:controller();

	{'EXIT', Pid, Reason } ->
	    io:format("~w terminated. Reason: ~w~n", [Pid,Reason]),
	    ?MODULE:controller()
		
    after 200 ->
	    ?MODULE:controller()
    end.


% start the controller
start() ->
    Controller = spawn(?MODULE, controller, []),
    % register
    register(controller,Controller).


new() ->
    Caller = self(),
    controller!{new,Caller},
    receive
	Pid ->
	    Pid
    end.
        

ver(Pid) ->
    Pid!print.

upd(Pid) ->
    Pid!code_switch.

stop(Pid) ->
    Pid!stop.


loop() ->
    receive
        code_switch ->
            hotSwap:loop();
        print ->
            io:format("This is version 7.3456~n"),    
            loop();
	stop ->
	    ok
    end.
