-module(mulAddServer).
-export([start/0, mul_add_server/0]).

% messages are of the kind {Op, X, Y, Pid} where Op can be mul or add

mul_add_server() ->
    receive 
        {mul, X, Y, Pid} ->
            Pid ! X*Y,
            mul_add_server();

        {add, X, Y, Pid} ->
            Pid ! X+Y,
            mul_add_server();

        stop ->
            io:format("Server stopping ...", [])
    end.

start() ->
    Server = spawn(mulAddServer, mul_add_server, []),
    Server ! {add, 2, 2, self()},
    Server ! {mul, 2, 4, self()},
    receive 
        P1 ->
            io:format("Sum 2+2 = ~B~n", [P1])
    end,
    
    receive 
        P2 ->
            io:format("Product 2*4 = ~B~n", [P2])
    end,
    
    Server!stop.
