-module(mulAddServer2).
-export([start/0, mul_add_server/0]).

% messages are of the kind {Op, X, Y, Pid} where Op can be mul or add

mul(Server, X,Y) -> 
    Server ! {mul, X, Y, self()}.

add(Server, X,Y) -> 
    Server ! {add, X, Y, self()}.
    

mul_add_server() ->
    receive 
        {mul, X, Y, Pid} ->
            Pid ! X*Y,
            mul_add_server();

        {add, X, Y, Pid} ->
            Pid ! X+Y,
            mul_add_server();

        stop ->
            io:format("Server stopping ...", []);
	M -> 
	    io:format("Invalid message ~w~n", [M])
    end.

start() ->
    Server = spawn(mulAddServer2, mul_add_server, []),
    add(Server, 2, 2),
    mul(Server, 2, 4),

    receive 
        P1 ->
            io:format("Sum 2+2 = ~B~n", [P1])
    end,
    
    receive 
        P2 ->
            io:format("Product 2*4 = ~B~n", [P2])
    end,
    
    Server!stop.
