% multiplication server (with sequential servant)
-module(mulServer).
-export([start/0, mul_server/0]).

mul_server() ->
    receive 
        {X, Y, Pid} ->
            Pid ! X*Y,
            mul_server();

        stop ->
            io:format("Server stopping ...", [])
    end.

start() ->
    Server = spawn(mulServer, mul_server, []),
    Server ! {2, 2, self()},
    Server ! {2, 4, self()},
    receive 
        P1 ->
            io:format("Product 2*2 = ~B~n", [P1])
    end,
    
    receive 
        P2 ->
            io:format("Product 2*4 = ~B~n", [P2])
    end,
    
    Server!stop.
