% multiplication server (requests served concurrently)
-module(mulServerConc).
-export([start/0, mul_server/0]).

mul_server() ->
    receive 
        {X, Y, Pid} ->
            spawn (fun () -> Pid ! X*Y end),
            mul_server();

        stop ->
            io:format("Server stopping ...", [])
    end.

start() ->
    Server = spawn(mulServerConc, mul_server, []),
    Server ! {2, 2, self()},
    Server ! {2, 4, self()},
    receive 
        P1 ->
            io:format("Product 2*2 = ~B~n", [P1])
    end,
    
    receive 
        P2 ->
            io:format("Product 2*4 = ~B~n", [P2])
    end,
    
    Server!stop.
