-module(quicksort).
-export([qsort/1, triqsort/1]).
 
%% qsort(List)
%% Sort a list of items
qsort([]) -> [];
qsort([Pivot|Rest]) ->
    qsort([ X || X <- Rest, X < Pivot]) ++ [Pivot] ++ qsort([ Y || Y <- Rest, Y >= Pivot]).

%% triqsort(List)
%% with tripartition
triqsort([]) -> [];
triqsort([Pivot|Rest]) ->
    triqsort([ X || X <- Rest, X < Pivot]) ++ [ X || X <-Rest, X=:=Pivot] ++ [Pivot] ++ triqsort([ Y || Y <- Rest, Y > Pivot]).
